//-----------------------------------------------------------------------------
//
//
// Caterpillar game by Matthew Mawdsley
//
// National Diploma Year 2 - Computing and IT
//
// This program is freeware!
//
// Sections of this code (DirectDraw and window initialisation) were take from
// DirectX tutorials
//
// There are also header files etc that contain MS written DirectX procedures
// Check the class list for all the "DXUtil_"'s
//
// *NOTE*
//
// You WILL need the DirectX SDK to compile this code
// I recommend SDK 7 and 8 for their sample code and 9 as it integrates better into
// the compiler.
//
// Each SDK is over 120mb in size, I made the mistake of downloading two days
// before I got broadband (surprise gift)
//
// Get all three, extract them all but only install SDK9. You'll still be able to use
// the example code from each one.
//
// I've done my best to annotate it and explain it as i went along but
// feel free to ask questions on http://www.juicystudio.com
//
//
//-----------------------------------------------------------------------------

#define STRICT
//#include <stdlib.h>
//#include <string.h>
//#include <fstream.h>	//some of these may be redundant, not sure which
//#include <windows.h>
//#include <dos.h>
#include "ddraw.h"
//#include <iostream.h>
//#include <conio.h>
#include <time.h>
//#include <mmsystem.h>
//#include <winuser.h>
#include <stdio.h>
#include "resource.h"
#include "ddutil.h"

//-----------------------------------------------------------------------------
// Defines, constants, and global variables
//-----------------------------------------------------------------------------
#define SAFE_DELETE(p)  { if(p) { delete (p);     (p)=NULL; } }
#define SAFE_RELEASE(p) { if(p) { (p)->Release(); (p)=NULL; } }

#define WINDOW_WIDTH    640
#define WINDOW_HEIGHT   480

#define SPRITE_DIAMETER 10
#define LARGE_SPRITE_DIAMETER 480

#define DEATH TEXT("You Lose! Press Escape to quit") //used in useless function

#define KEYDOWN(name,key) (name[key] & 0x80)

#define VK_0              0x30		//code for keypresses, I only use numbers 1 - 5, p and the arrow keys
#define VK_1              0x31		//but what the hell, here they all are in their hexadecimal glory
#define VK_2              0x32
#define VK_3              0x33
#define VK_4              0x34
#define VK_5              0x35
#define VK_6              0x36
#define VK_7              0x37
#define VK_8              0x38
#define VK_9              0x39

#define VK_A              0x41
#define VK_B              0x42
#define VK_C              0x43
#define VK_D              0x44
#define VK_E              0x45
#define VK_F              0x46
#define VK_G              0x47
#define VK_H              0x48
#define VK_I              0x49
#define VK_J              0x4A
#define VK_K              0x4B
#define VK_L              0x4C
#define VK_M              0x4D
#define VK_N              0x4E
#define VK_O              0x4F
#define VK_P              0x50
#define VK_Q              0x51
#define VK_R              0x52
#define VK_S              0x53
#define VK_T              0x54
#define VK_U              0x55
#define VK_V              0x56
#define VK_W              0x57
#define VK_X              0x58
#define VK_Y              0x59
#define VK_Z              0x5A

//-----------------------------------------------------------------------------
// Surfaces, less is better. Remember to destroy later
//-----------------------------------------------------------------------------

// Graphics surfaces

CDisplay*            g_pSmall            = NULL;
CDisplay*            g_pGrid             = NULL;
CSurface*            g_pLogoSurface      = NULL;  
CSurface*            g_pBigSurface       = NULL;
CSurface*            g_pBonusSurface     = NULL;
CSurface*            g_pGridSurface      = NULL;
CSurface*            g_pScoreSurface     = NULL;
CSurface*            g_pWelcomeSurface   = NULL;
CSurface*            g_pDeathSurface     = NULL;
CSurface*            g_pItemSurface      = NULL;
CSurface*            g_pBTSurface        = NULL;

// Text surfaces

CSurface*            g_pScoretextSurface      = NULL;
CSurface*            g_pCatertextSurface      = NULL;
CSurface*            g_pLeveltextSurface      = NULL;
CSurface*            g_pHighscoreSurface      = NULL;
CSurface*            g_pHighlevelSurface      = NULL;
CSurface*            g_pDifficultySurface     = NULL;

//-----------------------------------------------------------------------------
// Global variables, too many, don't know how to pass values in C++ :D
//-----------------------------------------------------------------------------

RECT                 g_rcFrame;
RECT                 g_rcViewport;          
RECT                 g_rcScreen;            
BOOL                 g_bActive           = FALSE; 
DWORD                g_dwLastTick;

struct segment
{					//co-ords of one snake segment
	int xpos;
	int ypos;
};

struct segment snake[101];	//co-ords of all snake segments

struct tag		//grid values
{
	bool apple;
	bool bonus;
	bool mine;
	bool head;
	bool snake;
	bool pill;
};

struct tag grid[43][43];	//grid array
int speed = 0;				//snake speed
int mines = 0;				//# of mines
int score = 0;				//current score
int direction = 0;			//direction of snake 2, 4, 6 ,8 - up, right, down, left
int life = 0;				//snake alive\dead
int itemcount = 0;			//count of items collected on current level
int length;					//length of snake
int bonuscount;				//used to indicate level up status
int level = 0;				//current level
int difficulty = 0;			//current difficulty
int pressed;				//used to ensure only 1 keypress per frame
int pause = 0;				//game paused/unpaused
int hscore[6];				//highscore array (array for easy use with difficulty 1-5)
int hl[6];					//highlevel array """""
int code;					//check whether highscore verification code has already been generated
int xcode[11];				//10 digit code used for highscore Vcode
int digit[11];				//general array used for outputing large numbers
int bonusmode;				//bonus round status
int counttime = 0;			//bonus round timer
int bx, by;					//global variables used for co-ords of pill (needed to remove pill if not picked up)
int lvlsave = 0;			//used to check whether pill already appeared on current level

VOID makelevel();			//makelevel function, resets variables, generates grid according to difficulty
LRESULT CALLBACK MainWndProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );
HRESULT WinInit( HINSTANCE hInst, int nCmdShow, HWND* phWnd, HACCEL* phAccel );
HRESULT InitDirectDraw( HWND hWnd );
VOID    FreeDirectDraw();				//lots o functions
HRESULT ProcessNextFrame( HWND hWnd );	//These two are the main ones
HRESULT DisplayFrame();				//They move stuff and display it
HRESULT RestoreSurfaces();	//never used, never tested
//-----------------------------------------------------------------------------
// entrance to program
//-----------------------------------------------------------------------------
int APIENTRY WinMain( HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR pCmdLine, int nCmdShow )
{
    MSG		 msg;
    HWND     hWnd;		//this does preparatory work, makes window, initialises DirectDraw etc
    HACCEL   hAccel;

    srand( GetTickCount() );

    if( FAILED( WinInit( hInst, nCmdShow, &hWnd, &hAccel ) ) )
        return FALSE;

    if( FAILED( InitDirectDraw( hWnd ) ) )
    {
        MessageBox( hWnd, TEXT("DirectDraw init failed. ")		//error
                    TEXT("The game will now exit. "), TEXT("Caterpillar by Matthew Mawdsley"), 
                    MB_ICONERROR | MB_OK );
        return FALSE;
    }

    g_dwLastTick = timeGetTime();

    while( TRUE )	//main loop
    {
        // Look for messages, if none are found then 
        // update the state and display it
        if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
        {
            if( 0 == GetMessage(&msg, NULL, 0, 0 ) )
            {
                // WM_QUIT was posted, so exit
                return (int)msg.wParam;
            }

            // Translate and dispatch the message
            if( 0 == TranslateAccelerator( hWnd, hAccel, &msg ) )
            {
                TranslateMessage( &msg ); 
                DispatchMessage( &msg );
            }
        }
        else
        {
            if( g_bActive )
            {
                // Move the sprites, blt them to the back buffer, then 
                // flip or blt the back buffer to the primary buffer
                if( FAILED( ProcessNextFrame( hWnd ) ) )
                {
                    SAFE_DELETE( g_pSmall );

                    MessageBox( hWnd, TEXT("Displaying the next frame failed. ")
                                TEXT("The game will now exit. "), TEXT("Caterpillar by Matthew Mawdsley"), 
                                MB_ICONERROR | MB_OK );
                    return FALSE;
                }
            }
            else
            {
                // Make sure we go to sleep if we have nothing else to do
                WaitMessage();

                // Ignore time spent inactive 
                g_dwLastTick = timeGetTime();
            }
        }
    }
}




//-----------------------------------------------------------------------------
// Create the window
//-----------------------------------------------------------------------------
HRESULT WinInit( HINSTANCE hInst, int nCmdShow, HWND* phWnd, HACCEL* phAccel )
{
    WNDCLASSEX wc;
    HWND       hWnd;
    HACCEL     hAccel;

    // Register the Window Class
    wc.cbSize        = sizeof(wc);
    wc.lpszClassName = TEXT("WindowedMode");
    wc.lpfnWndProc   = MainWndProc;
    wc.style         = CS_VREDRAW | CS_HREDRAW;
    wc.hInstance     = hInst;
    wc.hIcon         = LoadIcon( hInst, MAKEINTRESOURCE(IDI_MAIN) );
    wc.hIconSm       = LoadIcon( hInst, MAKEINTRESOURCE(IDI_MAIN) );
    wc.hCursor       = LoadCursor( NULL, IDC_ARROW );
    wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
    wc.lpszMenuName  = MAKEINTRESOURCE(IDR_MENU);
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;		//don't ask me what this means

    if( RegisterClassEx( &wc ) == 0 )
        return E_FAIL;

    // Load keyboard accelerators
    hAccel = LoadAccelerators( hInst, MAKEINTRESOURCE(IDR_MAIN_ACCEL) );	//fake key presses (Alt-X to quit)

    // Calculate the proper size for the window given a client of 640x480
    DWORD dwFrameWidth    = GetSystemMetrics( SM_CXSIZEFRAME );
    DWORD dwFrameHeight   = GetSystemMetrics( SM_CYSIZEFRAME );
    DWORD dwMenuHeight    = GetSystemMetrics( SM_CYMENU );
    DWORD dwCaptionHeight = GetSystemMetrics( SM_CYCAPTION );
    DWORD dwWindowWidth   = WINDOW_WIDTH  + dwFrameWidth * 2;
    DWORD dwWindowHeight  = WINDOW_HEIGHT + dwFrameHeight * 2 + 
                            dwMenuHeight + dwCaptionHeight;

    // Create and show the main window
    DWORD dwStyle = WS_OVERLAPPEDWINDOW & ~WS_MAXIMIZEBOX;		//made by me!
    hWnd = CreateWindowEx( 0, TEXT("Windowedmode"), TEXT("Caterpillar by Matthew Mawdsley"),
                           dwStyle, CW_USEDEFAULT, CW_USEDEFAULT,
  	                       dwWindowWidth, dwWindowHeight, NULL, NULL, hInst, NULL );
    if( hWnd == NULL )
    	return E_FAIL;

    ShowWindow( hWnd, nCmdShow );
    UpdateWindow( hWnd );

    *phWnd   = hWnd;
    *phAccel = hAccel;

    return S_OK;		//phew!
}




//-----------------------------------------------------------------------------
// Initialise DirectDraw, create surfaces etc
//-----------------------------------------------------------------------------
HRESULT InitDirectDraw( HWND hWnd )
{
    LPDIRECTDRAWPALETTE pDDPal = NULL; 
    HRESULT	hr;

    g_pSmall = new CDisplay();
    if( FAILED( hr = g_pSmall->CreateWindowedDisplay( hWnd, WINDOW_WIDTH, WINDOW_HEIGHT ) ) )
    {
        MessageBox( hWnd, TEXT("Failed initializing DirectDraw."),
                    TEXT("Caterpillar by Matthew Mawdsley"), MB_ICONERROR | MB_OK );
        return hr;
    }

    // Create and set the palette when in palettized color
    if( FAILED( hr = g_pSmall->CreatePaletteFromBitmap( &pDDPal, MAKEINTRESOURCE( WELCOME ) ) ) )
        return hr;												//used WELCOME bmp as has most colors

    g_pSmall->SetPalette( pDDPal );		//set the palette

    SAFE_RELEASE( pDDPal );

    // Create a surface, and draw a bitmap resource on it, bonus star (redundant, used in restore surfaces func (which is also redundant))  
    if( FAILED( hr = g_pSmall->CreateSurfaceFromBitmap( &g_pLogoSurface, MAKEINTRESOURCE( BONUS ), 
                                                          SPRITE_DIAMETER, SPRITE_DIAMETER ) ) )
        return hr;

	// Create a surface for the grid
    if( FAILED( hr = g_pSmall->CreateSurfaceFromBitmap( &g_pBigSurface, MAKEINTRESOURCE( GRID ), 
                                                          LARGE_SPRITE_DIAMETER, LARGE_SPRITE_DIAMETER ) ) )
        return hr;


	// Create a surface for the numbers 0 - 9
    if( FAILED( hr = g_pSmall->CreateSurfaceFromBitmap( &g_pScoreSurface, MAKEINTRESOURCE( NUMBERS ), 
                                                          100, 10 ) ) )
        return hr;

	// Create a surface for the welcome screen
    if( FAILED( hr = g_pSmall->CreateSurfaceFromBitmap( &g_pWelcomeSurface, MAKEINTRESOURCE( WELCOME ), 
                                                          640, 480 ) ) )
        return hr;

    // Create a surface for the loser message  
    if( FAILED( hr = g_pSmall->CreateSurfaceFromBitmap( &g_pDeathSurface, MAKEINTRESOURCE( LOSE ), 
                                                          320, 240 ) ) )
        return hr;

	// Create a surface for the items  
    if( FAILED( hr = g_pSmall->CreateSurfaceFromBitmap( &g_pItemSurface, MAKEINTRESOURCE( ITEMS ), 
                                                          50, 20 ) ) )
        return hr;

	// Create a surface for the bonus time img  
    if( FAILED( hr = g_pSmall->CreateSurfaceFromBitmap( &g_pBTSurface, MAKEINTRESOURCE( BT ), 
                                                          150, 100 ) ) )
        return hr;

	// Create a surface for txt
    if( FAILED( hr = g_pSmall->CreateSurfaceFromText( &g_pScoretextSurface, NULL, "Score : ", 
                                                        RGB(0,0,0), RGB(255, 255, 255) ) ) )
        return hr;

	// Create a surface for txt (notice it's green) 
    if( FAILED( hr = g_pSmall->CreateSurfaceFromText( &g_pCatertextSurface, NULL, "Caterpillar", 
                                                        RGB(0,0,0), RGB(0, 255, 0) ) ) )
        return hr;

	// Create a surface for txt 
    if( FAILED( hr = g_pSmall->CreateSurfaceFromText( &g_pLeveltextSurface, NULL, "Level : ", 
                                                        RGB(0,0,0), RGB(255, 255, 255) ) ) )
        return hr;

	// Create a surface for txt 
    if( FAILED( hr = g_pSmall->CreateSurfaceFromText( &g_pHighscoreSurface, NULL, "Highscore : ", 
                                                        RGB(0,0,0), RGB(255, 255, 255) ) ) )
        return hr;

	// Create a surface for txt 
    if( FAILED( hr = g_pSmall->CreateSurfaceFromText( &g_pHighlevelSurface, NULL, "on Level : ", 
                                                        RGB(0,0,0), RGB(255, 255, 255) ) ) )
        return hr;

	// Create a surface for txt
    if( FAILED( hr = g_pSmall->CreateSurfaceFromText( &g_pDifficultySurface, NULL, "Difficulty : ", 
                                                        RGB(0,0,0), RGB(255, 255, 255) ) ) )
        return hr;

    // Set the color key for the logo sprite to black
    if( FAILED( hr = g_pLogoSurface->SetColorKey( 0 ) ) )
        return hr;


    return S_OK;
}




//-----------------------------------------------------------------------------
// Destroy surfaces
//-----------------------------------------------------------------------------
VOID FreeDirectDraw()
{
	SAFE_DELETE( g_pBigSurface );
	SAFE_DELETE( g_pBonusSurface);
	SAFE_DELETE( g_pGridSurface);
    SAFE_DELETE( g_pLogoSurface );
    SAFE_DELETE( g_pDeathSurface );
	SAFE_DELETE( g_pScoretextSurface );
	SAFE_DELETE( g_pScoreSurface );
    SAFE_DELETE( g_pSmall );
	SAFE_DELETE( g_pWelcomeSurface );
	SAFE_DELETE( g_pHighscoreSurface );
	SAFE_DELETE( g_pHighlevelSurface );
	SAFE_DELETE( g_pDifficultySurface );
	SAFE_DELETE( g_pItemSurface );
	SAFE_DELETE( g_pBTSurface );
}




//-----------------------------------------------------------------------------
// Windows messages and stuff
//-----------------------------------------------------------------------------
LRESULT CALLBACK MainWndProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch (msg)
    {
		case WM_KEYDOWN:	//if keypressed
			if (life == 0)	//if not in game, generate level
			{
				if (wParam == VK_1)		//if key is 1 - 5, see defs at top
				{
					difficulty = 1;
					makelevel();
				}
				if (wParam == VK_2)
				{
					difficulty = 2;
					makelevel();
				}
				if (wParam == VK_3)
				{
					difficulty = 3;
					makelevel();
				}
				if (wParam == VK_4)
				{
					difficulty = 4;
					makelevel();
				}
				if (wParam == VK_5)
				{
					difficulty = 5;
					makelevel();
				}
			}
			if (life == 1 && pressed == 0)	//if game running and no key pressed this frame
			{								//alter direction
				if (wParam == VK_UP)
				{
					if (direction != 6)		//ensure player can't go back on themself
					{
						direction = 2;
						pressed = 1;
					}
				}
				if (wParam == VK_RIGHT)
				{
					if (direction != 8)
					{
						direction = 4;
						pressed = 1;
					}
				}
				if (wParam == VK_DOWN)
				{
					if (direction != 2)
					{
						direction = 6;
						pressed = 1;
					}
				}
				if (wParam == VK_LEFT)
				{
					if (direction != 4)
					{
						direction = 8;
						pressed = 1;
					}
				}
				if (wParam == VK_P)
					pause = 1 - pause;
			}
        case WM_COMMAND:
            switch( LOWORD(wParam) )
            {
                case IDM_EXIT:
                    // Received key/menu command to exit app
            	    PostMessage( hWnd, WM_CLOSE, 0, 0 );
                    return 0L;
            }
            break; // Continue with default processing

        case WM_PAINT:
            // Update the screen if we need to refresh
            if( g_pSmall )
            {
                // Display the new position of the sprites
                if( DisplayFrame() == DDERR_SURFACELOST )
                {
                    // If the surfaces were lost, then restore and try again
                    RestoreSurfaces();		//i doubt this is ever called
                    DisplayFrame();
                }
            }
            break;

        case WM_QUERYNEWPALETTE:
            if( g_pSmall )
            {
                // redo the palette, not a prob with 16-bit or over desktops
                LPDIRECTDRAWPALETTE pDDPal = NULL; 
                g_pSmall->GetFrontBuffer()->GetPalette( &pDDPal );
                g_pSmall->GetFrontBuffer()->SetPalette( pDDPal );
                SAFE_RELEASE( pDDPal );
            }
            break;

        case WM_GETMINMAXINFO:
            {
                // Don't allow resizing in windowed mode V.importante  
                // Fix the size of the window to 640x480 (client size)
                MINMAXINFO* pMinMax = (MINMAXINFO*) lParam;

                DWORD dwFrameWidth    = GetSystemMetrics( SM_CXSIZEFRAME );
                DWORD dwFrameHeight   = GetSystemMetrics( SM_CYSIZEFRAME );
                DWORD dwMenuHeight    = GetSystemMetrics( SM_CYMENU );
                DWORD dwCaptionHeight = GetSystemMetrics( SM_CYCAPTION );

                pMinMax->ptMinTrackSize.x = WINDOW_WIDTH  + dwFrameWidth * 2;
                pMinMax->ptMinTrackSize.y = WINDOW_HEIGHT + dwFrameHeight * 2 + 
                                            dwMenuHeight + dwCaptionHeight;

                pMinMax->ptMaxTrackSize.x = pMinMax->ptMinTrackSize.x;
                pMinMax->ptMaxTrackSize.y = pMinMax->ptMinTrackSize.y;
            }
            return 0L;

        case WM_MOVE:
	        if( g_pSmall )
		        g_pSmall->UpdateBounds();
            return 0L;

        case WM_EXITMENULOOP:
            // Ignore time spent in menu
            g_dwLastTick = timeGetTime();
            break;

        case WM_EXITSIZEMOVE:
            // Ignore time spent resizing
            g_dwLastTick = timeGetTime();
            break;

        case WM_SIZE:
            // Check to see if we are losing our window...
            if( SIZE_MAXHIDE==wParam || SIZE_MINIMIZED==wParam )
                g_bActive = FALSE;
            else
                g_bActive = TRUE;

	        if( g_pSmall )
		        g_pSmall->UpdateBounds();
            break;
            
        case WM_DESTROY:
            // Cleanup and close the app
            FreeDirectDraw();
            PostQuitMessage( 0 );
            return 0L;
    }

    return DefWindowProc(hWnd, msg, wParam, lParam);
}




//-----------------------------------------------------------------------------
// Move things, check for collisions etc
//-----------------------------------------------------------------------------
HRESULT ProcessNextFrame( HWND hWnd )
{
    HRESULT hr;

	int x, y;

    // Figure how much time has passed since the last time
    DWORD dwCurrTick = timeGetTime();
    DWORD dwTickDiff = dwCurrTick - g_dwLastTick;	//timer, used for altering speed of game

    // Don't update if no time has passed 
    if( dwTickDiff < speed )
        return S_OK;

    g_dwLastTick = dwCurrTick;

	if (direction != 0 && pause == 0)			//simple timer to delay appearance of pill
		counttime = counttime + dwTickDiff;
		if (counttime == dwTickDiff)
			counttime = counttime * 2;

						//wait 30 secs inbetween pills
	if (counttime >= 30000 && bx == 0 && lvlsave != level)	//only generate pill if not already
	{														//appeared on current level
		do
		{
			bx = rand( )%42 + 1;	//between 1 and 42
			by = rand( )%42 + 1;	//check if other item occupies space
		} while (grid[bx][by].pill == true || grid[bx][by].apple == true || grid[bx][by].bonus == true || grid[bx][by].mine == true || grid[bx][by].snake == true);
		grid[bx][by].pill = true;
		counttime = 0;		//reset timer
		lvlsave = level;	//save the level number
	}

	if (counttime >= (5000 + 1000 * (5 - difficulty)) && bx != 0)	//destroy the pill if not already eaten
	{
		grid[bx][by].pill = false;
		counttime = 0;
		bonusmode = 0;
		bx = 0;		//reset bx and by
		by = 0;
	}

    // Check the cooperative level before rendering
    if( FAILED( hr = g_pSmall->GetDirectDraw()->TestCooperativeLevel() ) )
    {
        switch( hr )
        {
            case DDERR_EXCLUSIVEMODEALREADYSET:
                // Do nothing because some other app has exclusive mode
                Sleep(10);
                return S_OK;

            case DDERR_WRONGMODE:
                // The display mode changed on us. Update the
                // DirectDraw surfaces accordingly
                FreeDirectDraw();
                return InitDirectDraw( hWnd );
        }
        return hr;
    }

    // Update the positions of the sprites on the screen
	if (direction != 0 && pause == 0)	//if snake is moving and game is not paused
	{
		grid[snake[1].xpos][snake[1].ypos].head = false;	//remove head from grid	
		grid[snake[length].xpos][snake[length].ypos].snake = false;
		for (int loop1 = length; loop1 > 1; loop1--)
		{
			snake[loop1].xpos = snake[loop1 - 1].xpos;	//pass co-ords of snake along each segment
			snake[loop1].ypos = snake[loop1 - 1].ypos;
			grid[snake[loop1].xpos][snake[loop1].ypos].snake = true;
		}

		if (direction == 2)
		{
			snake[1].ypos = snake[1].ypos - 1;
			if (snake[1].ypos == 0)		//make snake appear on other side
				snake[1].ypos = 42;
		}
		else if (direction == 4)
		{
			snake[1].xpos = snake[1].xpos + 1;
			if (snake[1].xpos == 43)
				snake[1].xpos = 1;
		}
		else if (direction == 6)
		{
			snake[1].ypos = snake[1].ypos + 1;
			if (snake[1].ypos == 43)
				snake[1].ypos = 1;
		}
		else if (direction == 8)
		{
			snake[1].xpos = snake[1].xpos - 1;
			if (snake[1].xpos == 0)
				snake[1].xpos = 42;
		}
		grid[snake[1].xpos][snake[1].ypos].head = true;	//add head to grid
	}

	if (grid[snake[1].xpos][snake[1].ypos].apple == true)	//if collide with apple
	{
		grid[snake[1].xpos][snake[1].ypos].apple = false;	//remove apple
		score = score + level * 2;	//increase score
		if (score > hscore[difficulty])	//update highscore and level
		{
			hscore[difficulty] = score;
			hl[difficulty] = level;
		}
		itemcount = itemcount + 1;	//count the items collected
		if (itemcount == 5)			//if 5 collected make portal for next level
		{
			itemcount = 0;
			bonuscount = 1;		//ensure new apple isn't created
			do
			{
				x = rand( )%42 + 1;
				y = rand( )%42 + 1;
			} while (grid[x][y].pill == true || grid[x][y].apple == true || grid[x][y].bonus == true || grid[x][y].mine == true || grid[x][y].snake == true);
			grid[x][y].bonus = true;
		}
		length = length + 1;	//increase length of snake
		if (length > 100)		//length cap
			length = 100;
		speed = speed - 1;		//decrease time between loops (speed up)
		if (speed < 30)
			speed = 30;			//speed cap of 30ms
		if (bonuscount == 0)	//if allowed to make new apple
		{
			do
			{
				x = rand( )%42 + 1;
				y = rand( )%42 + 1;
			} while (grid[x][y].pill == true || grid[x][y].apple == true || grid[x][y].bonus == true || grid[x][y].mine == true || grid[x][y].snake == true);
			grid[x][y].apple = true;
		}
	}
	else if (grid[snake[1].xpos][snake[1].ypos].mine == true)	//if collide with mine
	{
		if (bonusmode == 0)		//if not in bonus mode
		{
			life = 0;			//dead
			/*char buffer[80];

			int number;

			number = counttime;

			sprintf(buffer,"%d",number);
			MessageBox( hWnd, TEXT(buffer),
                        TEXT("Caterpillar by Matthew Mawdsley"), MB_ICONERROR | MB_OK );*/
		}
		else if (bonusmode == 1)	//if in bonus mode
		{
			grid[snake[1].xpos][snake[1].ypos].mine = false;	//remove mine from grid
			score = score + level * 20;		//increase score loads
			if (score > hscore[difficulty])	//update highscore and level
			{
				hscore[difficulty] = score;
				hl[difficulty] = level;
			}
			grid[snake[length].xpos][snake[length].ypos].snake = false;	//remove snake tail from grid
			grid[snake[length].xpos][snake[length].ypos].mine = true;	//change tail to mine
			length = length - 1;		//decrease length of snake
			if (length < 5)				//minimum length
				length = 5;

			speed = speed + 1;			//add 1ms to delay (slow down)
			if (speed > 235 - difficulty * 35)	//minimum speed equal to difficulty's default speed
				speed = 235 - difficulty * 35;
		}
	}
	else if (grid[snake[1].xpos][snake[1].ypos].snake == true)	//if collide with snake
	{
		life = 0;		//dead
	}
	else if (grid[snake[1].xpos][snake[1].ypos].bonus == true)	//if collide with bonus (exit)
	{
		score = score + level * 5;	//increase score
		level = level + 1;			//increase level (score multiplier)
		if (score > hscore[difficulty])	//update highscore and level
		{
			hscore[difficulty] = score;
			hl[difficulty] = level;
		}
		bonuscount = 0;		//bonuscount is zero (allow apples to be made)
		grid[snake[1].xpos][snake[1].ypos].bonus = false;	//remove bonus from grid
		length = length + 1;	//increase length
		if (length > 100)		//length cap
			length = 100;
		speed = speed - 1;		//increase speed
		if (speed < 30)			//speed cap
			speed = 30;
		do
		{
			x = rand( )%42 + 1;	//create new apple
			y = rand( )%42 + 1;
		} while (grid[x][y].pill == true || grid[x][y].apple == true || grid[x][y].bonus == true || grid[x][y].mine == true || grid[x][y].snake == true);
		grid[x][y].apple = true;
	}

	if (grid[snake[1].xpos][snake[1].ypos].pill == true)	//if collide with pill
	{
		grid[snake[1].xpos][snake[1].ypos].pill = false;	//remove pill from grid
		bonusmode = 1;	//set mode to bonus
		counttime = 0;	//reset timer
	}

    if( FAILED( hr = DisplayFrame() ) )	//if frame not displayed
    {
        if( hr != DDERR_SURFACELOST )	//never called
            return hr;

        // The surfaces were lost so restore them 
        RestoreSurfaces();
    }

    return S_OK;
}





//-----------------------------------------------------------------------------
// The blitter
//-----------------------------------------------------------------------------
HRESULT DisplayFrame()
{
    HRESULT hr;
	long int temp, mult; //used for large numbers outputting
    
	if (life == 1 && level != 0)	//if snake alive and not on lvl 0
	{
		g_pSmall->Clear( 0 );	//empty buffer

		// Blt grid on to the backbuffer, ignoring errors until the flip
		g_pSmall->Blt( 0, 0, g_pBigSurface, NULL );//blit grid

		for (int loop1 = 1; loop1 < 43; loop1++)	//check each co-ord on grid for items
		{
			for (int loop2 = 1; loop2 < 43; loop2++)
			{
				if (grid[loop1][loop2].mine == true)	//if co-ord is a mine
				{
					if (bonusmode == 0)		//if not in bonus mode use purple X for pic
					{
						g_rcFrame.left = 10;	//move the rectangle in the items picture (see resources)
						g_rcFrame.top = 10;
						g_rcFrame.right = g_rcFrame.left + 10;	//all items are 10*10
						g_rcFrame.bottom = g_rcFrame.top + 10;
					}
					else if (bonusmode == 1)	//if in bonus mode use star for pic
					{
						g_rcFrame.left = 30;	//co-ords of star pic are different from X
						g_rcFrame.top = 10;
						g_rcFrame.right = g_rcFrame.left + 10;
						g_rcFrame.bottom = g_rcFrame.top + 10;
					}

					g_pSmall->Blt( loop1 * 10 + 20, loop2 * 10 + 20, g_pItemSurface, &g_rcFrame );	
										//blit the mine to the grid
				}
				if (grid[loop1][loop2].snake == true)	//if co-ord is a snake (body not head)
				{
					g_rcFrame.left = 0;		//co-ords of torso in the items pic
					g_rcFrame.top = 0;
					g_rcFrame.right = g_rcFrame.left + 10;
					g_rcFrame.bottom = g_rcFrame.top + 10;
					g_pSmall->Blt( loop1 * 10 + 20, loop2 * 10 + 20, g_pItemSurface, &g_rcFrame );	//blit the pic
				}
				if (grid[loop1][loop2].head == true)	//if co-ord is snake head
				{
					if (direction == 2)		//use different head for each direction
					{
						g_rcFrame.left = 10;	//each head has different co-ords in items pic
						g_rcFrame.top = 0;
						g_rcFrame.right = g_rcFrame.left + 10;
						g_rcFrame.bottom = g_rcFrame.top + 10;
					}
					else if (direction == 4)
					{
						g_rcFrame.left = 20;
						g_rcFrame.top = 0;
						g_rcFrame.right = g_rcFrame.left + 10;
						g_rcFrame.bottom = g_rcFrame.top + 10;
					}
					else if (direction == 6)
					{
						g_rcFrame.left = 30;
						g_rcFrame.top = 0;
						g_rcFrame.right = g_rcFrame.left + 10;
						g_rcFrame.bottom = g_rcFrame.top + 10;
					}
					else if (direction == 8)
					{
						g_rcFrame.left = 40;
						g_rcFrame.top = 0;
						g_rcFrame.right = g_rcFrame.left + 10;
						g_rcFrame.bottom = g_rcFrame.top + 10;
					}
					else
					{
						g_rcFrame.left = 20;
						g_rcFrame.top = 0;
						g_rcFrame.right = g_rcFrame.left + 10;
						g_rcFrame.bottom = g_rcFrame.top + 10;
					}

					g_pSmall->Blt( loop1 * 10 + 20, loop2 * 10 + 20, g_pItemSurface, &g_rcFrame );
				}			//blit the head
				if (grid[loop1][loop2].apple == true)	//if co-ord is an apple
				{
					g_rcFrame.left = 20;	//move rectangle
					g_rcFrame.top = 10;
					g_rcFrame.right = g_rcFrame.left + 10;
					g_rcFrame.bottom = g_rcFrame.top + 10;
					g_pSmall->Blt( loop1 * 10 + 20, loop2 * 10 + 20, g_pItemSurface, &g_rcFrame );
				}			//blit apple
				
				if (grid[loop1][loop2].pill == true)	//if co-ord is pill
				{
					g_rcFrame.left = 40;	//move rectangle
					g_rcFrame.top = 10;
					g_rcFrame.right = g_rcFrame.left + 10;
					g_rcFrame.bottom = g_rcFrame.top + 10;
					g_pSmall->Blt( loop1 * 10 + 20, loop2 * 10 + 20, g_pItemSurface, &g_rcFrame );
				}			//blit pill
				if (grid[loop1][loop2].bonus == true)	//if co-ord is bonus (warp)
				{
					g_rcFrame.left = 0;		//move rectangle
					g_rcFrame.top = 10;
					g_rcFrame.right = g_rcFrame.left + 10;
					g_rcFrame.bottom = g_rcFrame.top + 10;
					g_pSmall->Blt( loop1 * 10 + 20, loop2 * 10 + 20, g_pItemSurface, &g_rcFrame );
				}		//blit bonus
			}
		}
	
		g_pSmall->Blt ( 515, 50, g_pCatertextSurface, NULL );	//blit text, positions never change
		g_pSmall->Blt ( 485, 96, g_pScoretextSurface, NULL );
		g_pSmall->Blt ( 485, 130, g_pLeveltextSurface, NULL );
		g_pSmall->Blt ( 485, 164, g_pHighscoreSurface, NULL);
		g_pSmall->Blt ( 485, 198, g_pHighlevelSurface, NULL);
		g_pSmall->Blt ( 485, 232, g_pDifficultySurface, NULL);

		temp = score;	//this generic code splits a number down into single digits and blits them one by one

		for (loop1 = 5; loop1 > 0; loop1--)
		{
			mult = 10;	//multplier used instead of powers
			for (int loop2 = 1; loop2 < loop1 - 1; loop2++)
				mult = mult * 10;
			if (loop1 == 1)
				mult = 1;
			for (loop2 = 0; loop2 < 10; loop2++)
			{
				if (temp < (loop2 * mult + mult) && temp > (loop2 * mult - 1))
					digit[loop1] = loop2;
			}

			temp = temp - digit[loop1] * mult;
			g_rcFrame.left = digit[loop1] * 10;		//move rectangle
			g_rcFrame.top = 0;
			g_rcFrame.right = g_rcFrame.left + 10;
			g_rcFrame.bottom = g_rcFrame.top + 10;

			g_pSmall->Blt ( 565 + (5 - loop1) * 10, 100, g_pScoreSurface, &g_rcFrame);
		}				//blit the number

		temp = level;		//same code but for the current level

		for (loop1 = 3; loop1 > 0; loop1--)
		{
			mult = 10;
			for (int loop2 = 1; loop2 < loop1 - 1; loop2++)
				mult = mult * 10;
			if (loop1 == 1)
				mult = 1;
			for (loop2 = 0; loop2 < 10; loop2++)
			{
				if (temp < (loop2 * mult + mult) && temp > (loop2 * mult - 1))
					digit[loop1] = loop2;
			}

			temp = temp - digit[loop1] * mult;
			g_rcFrame.left = digit[loop1] * 10;
			g_rcFrame.top = 0;
			g_rcFrame.right = g_rcFrame.left + 10;
			g_rcFrame.bottom = g_rcFrame.top + 10;

			g_pSmall->Blt ( 585 + (3 - loop1) * 10, 134, g_pScoreSurface, &g_rcFrame);
		}

		temp = hscore[difficulty];	//same code used for highscore

		for (loop1 = 5; loop1 > 0; loop1--)
		{
			mult = 10;
			for (int loop2 = 1; loop2 < loop1 - 1; loop2++)
				mult = mult * 10;
			if (loop1 == 1)
				mult = 1;
			for (loop2 = 0; loop2 < 10; loop2++)
			{
				if (temp < (loop2 * mult + mult) && temp > (loop2 * mult - 1))
					digit[loop1] = loop2;
			}

			temp = temp - digit[loop1] * mult;
			g_rcFrame.left = digit[loop1] * 10;
			g_rcFrame.top = 0;
			g_rcFrame.right = g_rcFrame.left + 10;
			g_rcFrame.bottom = g_rcFrame.top + 10;

			g_pSmall->Blt ( 565 + (5 - loop1) * 10, 168, g_pScoreSurface, &g_rcFrame);
		}

		temp = hl[difficulty];		//same code used for high level

		for (loop1 = 3; loop1 > 0; loop1--)
		{
			mult = 10;
			for (int loop2 = 1; loop2 < loop1 - 1; loop2++)
				mult = mult * 10;
			if (loop1 == 1)
				mult = 1;
			for (loop2 = 0; loop2 < 10; loop2++)
			{
				if (temp < (loop2 * mult + mult) && temp > (loop2 * mult - 1))
					digit[loop1] = loop2;
			}

			temp = temp - digit[loop1] * mult;
			g_rcFrame.left = digit[loop1] * 10;
			g_rcFrame.top = 0;
			g_rcFrame.right = g_rcFrame.left + 10;
			g_rcFrame.bottom = g_rcFrame.top + 10;

			g_pSmall->Blt ( 585 + (3 - loop1) * 10, 202, g_pScoreSurface, &g_rcFrame);
		}

		g_rcFrame.left = difficulty * 10;
		g_rcFrame.top = 0;
		g_rcFrame.right = g_rcFrame.left + 10;
		g_rcFrame.bottom = g_rcFrame.top + 10;

		g_pSmall->Blt ( 605, 236, g_pScoreSurface, &g_rcFrame);

		if (bonusmode == 1)		//this code displays the timer for remaining time in bonus mode
		{
			temp = (5000 + 1000 * (5 - difficulty)) - counttime;	//the time in bonus mode is controlled by this equation

			for (loop1 = 5; loop1 > 0; loop1--)		//same code to display numbers as above
			{
				mult = 10;
				for (int loop2 = 1; loop2 < loop1 - 1; loop2++)
					mult = mult * 10;
				if (loop1 == 1)
					mult = 1;
				for (loop2 = 0; loop2 < 10; loop2++)
				{
					if (temp < (loop2 * mult + mult) && temp > (loop2 * mult - 1))
						digit[loop1] = loop2;
				}

				temp = temp - digit[loop1] * mult;
				g_rcFrame.left = digit[loop1] * 10;
				g_rcFrame.top = 0;
				g_rcFrame.right = g_rcFrame.left + 10;
				g_rcFrame.bottom = g_rcFrame.top + 10;

				g_pSmall->Blt ( 520 + (5 - loop1) * 10, 420, g_pScoreSurface, &g_rcFrame);
			}

			g_rcFrame.left = difficulty * 10;	//difficulty is only 1 digit, no for loop required
			g_rcFrame.top = 0;
			g_rcFrame.right = g_rcFrame.left + 10;
			g_rcFrame.bottom = g_rcFrame.top + 10;

			g_pSmall->Blt ( 605, 236, g_pScoreSurface, &g_rcFrame);
		}

		if (bonusmode == 1)		//if in bonus mode, display "BONUS TIME!" picture in bottom right corner
			g_pSmall->Blt ( 470, 280, g_pBTSurface, NULL);
	}
	if (life == 0 && level != 0 && direction != 0)		//if snake is dead but game has been played at least once
	{
		g_pSmall->Blt ( 160, 120, g_pDeathSurface, NULL);		//display the game over bmp

		if (code == 0)		//generate highscore verification code and display at top left
		{
			temp = score * level * difficulty;

			for (int loop1 = 9; loop1 > 0; loop1--)
			{
				mult = 10;
				for (int loop2 = 1; loop2 < loop1 - 1; loop2++)
					mult = mult * 10;
				if (loop1 == 1)
					mult = 1;
				for (loop2 = 0; loop2 < 10; loop2++)
				{
					if (temp < (loop2 * mult + mult) && temp > (loop2 * mult - 1))
						digit[loop1] = loop2;
				}

				temp = temp - digit[loop1] * mult;

				g_rcFrame.left = digit[loop1] * 10;
				g_rcFrame.top = 0;
				g_rcFrame.right = g_rcFrame.left + 10;
				g_rcFrame.bottom = g_rcFrame.top + 10;

				g_pSmall->Blt ( 7 + (9 - loop1) * 10, 10, g_pScoreSurface, &g_rcFrame);
			}

			for (loop1 = 0; loop1 < 10; loop1++)
			{
				xcode[digit[loop1]] = xcode[digit[loop1]] + 1;
			}

			for (loop1 = 0; loop1 < 10; loop1++)
			{
				if (xcode[loop1] == 1 || xcode[loop1] == 3 || xcode[loop1] == 5 || xcode[loop1] == 7 || xcode[loop1] == 9)
					digit[loop1] = ((rand()%4 + 0) * 2) + 1;
				if (xcode[loop1] == 0 || xcode[loop1] == 2 || xcode[loop1] == 4 || xcode[loop1] == 6 || xcode[loop1] == 8)
					digit[loop1] = (rand()%4 + 0) * 2;

				g_rcFrame.left = digit[loop1] * 10;
				g_rcFrame.top = 0;
				g_rcFrame.right = g_rcFrame.left + 10;
				g_rcFrame.bottom = g_rcFrame.top + 10;

				g_pSmall->Blt ( 97 + (9 - loop1) * 10, 10, g_pScoreSurface, &g_rcFrame);
			}
			code = 1;	//ensure code is only generated once
		}
	}
	if (level == 0 && direction == 0)		//if game has not been played
	{
		g_pSmall->Clear( 0 );
		g_pSmall->Blt ( 0, 0, g_pWelcomeSurface, NULL);		//display welcome screen
	}

    if( FAILED( hr = g_pSmall->Present() ) )
        return hr;

	pressed = 0;	//reset pressed to 0 so main loop will accept keyboard input again

    return S_OK;
}




//-----------------------------------------------------------------------------
// Restore surfaces not used and not fully functional, expect a big flicker if it ever executes
//-----------------------------------------------------------------------------
HRESULT RestoreSurfaces()
{
    LPDIRECTDRAWPALETTE pDDPal = NULL; 
    HRESULT hr;

    if( FAILED( hr = g_pSmall->GetDirectDraw()->RestoreAllSurfaces() ) )
        return hr;

    if( FAILED( hr = g_pDeathSurface->DrawText( NULL, DEATH, //draw death text, early version used txt instead of the death bmp
                                               0, 0, RGB(0,0,0), RGB(255, 255, 0) ) ) )
        return hr;

    if( FAILED( hr = g_pSmall->CreatePaletteFromBitmap( &pDDPal, MAKEINTRESOURCE( BONUS ) ) ) )	//restore pallete
        return hr;

    g_pSmall->SetPalette( pDDPal );

    SAFE_RELEASE( pDDPal );

    if( FAILED( hr = g_pLogoSurface->DrawBitmap( MAKEINTRESOURCE( BONUS ),
                                                 SPRITE_DIAMETER, SPRITE_DIAMETER ) ) )
        return hr;

    return S_OK;
}

void makelevel()		//generate the first level according to difficulty
{
	int x, y;

	life = 1;		//snake is alive
	mines = difficulty * 3;	//set # of mines

	level = 1;		//set start level

	score = 0;		//reset score etc
	pause = 0;
	code = 0;

	itemcount = 0;	//reset other things
	bonuscount = 0;
	counttime = 0;
	bonusmode = 0;
	lvlsave = 0;

	for (int loop1 = 0; loop1 < 11; loop1++)	//wipe the arrays
	{	
		xcode[loop1] = 0;
		digit[loop1] = 0;
	}

	speed = 235 - difficulty * 35;	//set the speed
	length = difficulty * 10;		//set the length

	direction = 0;		//ensure snake doesn't move straight away

	srand(time(0));		//seed the random time

	for (loop1 = 1; loop1 < 43; loop1++)	//wipe the grid clean
	{
		for (int loop2 = 1; loop2 < 43; loop2++)
		{
			grid[loop1][loop2].apple = false;
			grid[loop1][loop2].bonus = false;
			grid[loop1][loop2].mine = false;
			grid[loop1][loop2].snake = false;
			grid[loop1][loop2].head = false;
			grid[loop1][loop2].pill = false;
		}
	}

	do
	{
		x = rand( )%42 + 1;	//generate the first apple
		y = rand( )%42 + 1;
	} while (grid[x][y].apple == true || grid[x][y].bonus == true || grid[x][y].mine == true || grid[x][y].snake == true);
	grid[x][y].apple = true;

	for (loop1 = 0; loop1 < mines; loop1++)		//create as many mines as needed
	{
		do
		{
			x = rand( )%42 + 1;
			y = rand( )%42 + 1;
		} while (grid[x][y].apple == true || grid[x][y].bonus == true || grid[x][y].mine == true || grid[x][y].snake == true);
		grid[x][y].mine = true;
	}

	do			//create a start position for the snake
	{
		x = rand( )%42 + 1;
		y = rand( )%42 + 1;
	} while (grid[x][y].apple == true || grid[x][y].bonus == true || grid[x][y].mine == true || grid[x][y].snake == true);
	grid[x][y].head = true;

	for (loop1 = 0; loop1 < length + 1; loop1++)	//wipe the snake array clean, all segments are blitted off screen out of view
	{
		snake[loop1].xpos = 0;	
		snake[loop1].ypos = 0;
	}

	snake[1].xpos = x;	//set the snake start position
	snake[1].ypos = y;
}


//-----------------------------------------------------------------------------
//
//	That's all folks! ;)
//
//-----------------------------------------------------------------------------